 /*
  */

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.plaf.metal.MetalLookAndFeel;
import oracle.jdeveloper.layout.*;
import oracle.dacf.layout.*;


public class EX5Lib extends JFrame {

   //GUI stuff
   BorderLayout borderLayout1 = new BorderLayout();
   JPanel jPanel1 = new JPanel();
   JPanel jPanel2 = new JPanel();
   JLabel statusBar = new JLabel();
   JLabel ex5Label;
   JButton jButton1 = new JButton(new ImageIcon("browse.jpg", new String("browse")));
   JMenuBar menuBar1 = new JMenuBar();
   JMenu menuFile = new JMenu();
   JMenuItem menuFileExit = new JMenuItem();
   JMenuItem menuFileLoad = new JMenuItem();
   JScrollPane scrollpane;
   JTable jTable1;
   DefaultTableModel rowSet;
   JTextField jTextField1 = new JTextField();
   GridLayout gridLayout1 = new GridLayout();
  BorderLayout borderLayout2 = new BorderLayout();

   public static void main(String[] args)
   {
    try {
      MetalLookAndFeel.setCurrentTheme(new EX5Theme());
      UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
      Frame frame = new EX5Lib(args);
      //Center the window
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/2);
      frame.addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent e) { System.exit(0); } });
      frame.setVisible(true);
    }
    catch (Exception e) {
      System.out.println( "" + e);
    }
   }  // main

   // Constructor
   public EX5Lib(String[] args)
   {
      try {
        jbInit();
      }
      catch (Exception e){
        e.printStackTrace();
      }
   }

  private void jbInit() throws Exception {
	  ex5Label = new JLabel(new ImageIcon("ex5.jpg", new String("ex5")));
	  ex5Label.setPreferredSize(new Dimension(420, 100));

    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(640, 480));
    this.setTitle("EX5Lib");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileLoad.setText("Load");
    rowSet = new DefaultTableModel(0,7);
    rowSet.setColumnIdentifiers(new Object[]{"Loc","No.","Bnk-no.","Cat","Name","Type","Lyrs"});
    jTable1 = new JTable(rowSet);
    scrollpane = new JScrollPane(jTable1);
    jButton1.setPreferredSize(new Dimension(56,18));
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jPanel1.setPreferredSize(new Dimension(100, 100));
    javax.swing.border.BevelBorder border = new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED);
    jPanel1.setBorder(border);
    border.getBorderInsets((Component)jPanel1,new Insets(20,20,20,20));
    jPanel2.setLayout(borderLayout2);
    jPanel1.setLayout(gridLayout1);
    menuFile.add(menuFileLoad);
    menuFile.add(menuFileExit);
    menuBar1.add(menuFile);
    this.setJMenuBar(menuBar1);
    this.setResizable(false);
    this.getContentPane().getInsets();
    jPanel1.add(scrollpane, null);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);
    this.getContentPane().add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(ex5Label, BorderLayout.NORTH);
    jPanel2.add(jTextField1, BorderLayout.CENTER);
    jPanel2.add(jButton1, BorderLayout.EAST);
    statusBar.setText("EX5Lib");
    menuFileExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fileExit_ActionPerformed(e);
      }
    });
    menuFileLoad.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fileLoad_ActionPerformed(e);
      }
    });
  }

   private void initialize() {

    //Vars
    String strVoiceName;
    int cat;
    String strVoiceCat;
    int type;
    String strVoiceType;
    int count;
    String strLayerCount;
    String bankName;
    String[] bankNames = new String[2];
    bankNames[0] = "I-1";
    bankNames[1] = "I-2";
    String strNumber;
    String strLocation;
    String[] strLocations = new String[8];
    strLocations[0] = "A";
    strLocations[1] = "B";
    strLocations[2] = "C";
    strLocations[3] = "D";
    strLocations[4] = "E";
    strLocations[5] = "F";
    strLocations[6] = "G";
    strLocations[7] = "H";
    String[] strVoiceCatNames = new String[23];
    strVoiceCatNames[0] = "--";
    strVoiceCatNames[1] = "Pf";
    strVoiceCatNames[2] = "Cp";
    strVoiceCatNames[3] = "Or";
    strVoiceCatNames[4] = "Gt";
    strVoiceCatNames[5] = "Ba";
    strVoiceCatNames[6] = "St";
    strVoiceCatNames[7] = "En";
    strVoiceCatNames[8] = "Br";
    strVoiceCatNames[9] = "Rd";
    strVoiceCatNames[10] = "Pi";
    strVoiceCatNames[11] = "Ld";
    strVoiceCatNames[12] = "Pd";
    strVoiceCatNames[13] = "Fx";
    strVoiceCatNames[14] = "Et";
    strVoiceCatNames[15] = "Pc";
    strVoiceCatNames[16] = "Se";
    strVoiceCatNames[17] = "Dr";
    strVoiceCatNames[18] = "Sc";
    strVoiceCatNames[19] = "Vo";
    strVoiceCatNames[20] = "Co";
    strVoiceCatNames[21] = "Wv";
    strVoiceCatNames[22] = "Sq";
    String[] strVoiceTypes = new String[16];
    strVoiceTypes[0] = "AWM";
    strVoiceTypes[1] = "VL+AWM";
    strVoiceTypes[2] = "FDSP";
    strVoiceTypes[3] = "AN(Poly)+AWM";
    strVoiceTypes[4] = "AN(Layer)+AWM";
    strVoiceTypes[5] = "AN+FDSP";
    strVoiceTypes[6] = "Drum Voice";
    strVoiceTypes[7] = "??????";
    strVoiceTypes[8] = "AWM";
    strVoiceTypes[9] = "VL+AWM";
    strVoiceTypes[10] = "FDSP";
    strVoiceTypes[11] = "AN(Poly)+AWM";
    strVoiceTypes[12] = "AN(Layer)+AWM";
    strVoiceTypes[13] = "AN+FDSP";
    strVoiceTypes[14] = "Drum Voice";
    strVoiceTypes[15] = "??????";

    FileInputStream sf;

    int varPosition = 2176; // position of first Voice Name
    int varOffset = 236;    //236 is the offset from Name to Name
    int varMaxVoices = 255; //Maximum number of voices
    byte[] buffer = new byte[varOffset];
    int read = 0;
    int lngCount =0;

    //clean up the old list
    while(rowSet.getRowCount()>0)rowSet.removeRow(0);

    try {
      //get the file
      sf = new FileInputStream(jTextField1.getText());
      //skip the first part
      sf.skip(varPosition);
      //Get info from the Voice files...
      while(lngCount <= varMaxVoices){
        read = sf.read(buffer);
        //Voice Name is the first one with 12 char's long
        strVoiceName = new String(buffer,0,12);
        //Voice Category is offset 1 from Voice Name
        cat = buffer[12];
        strVoiceCat = strVoiceCatNames[cat];
        //Voice Type is offset 48 from Voice Name
        type = buffer[12 + 48 - 1];
        while(type>=16)type=type-16;
        //Layer Count is offset 3 from Voice Name
        strVoiceType = strVoiceTypes[type];
        count = buffer[12 + 3 - 1];
        //translate into layer numbers (quick and dirty)
        if(count == 1 || count == 2 || count == 4 || count == 8)
          count = 1;
        if(count == 3 || count == 5 || count == 6 || count == 9)
          count = 2;
        if(count == 7 || count == 11 || count == 13 || count == 14)
          count = 3;
        if(count == 15 || count == 16)
          count = 4;
        strLayerCount = String.valueOf(count);
        //translate bankNames,location and number from lngCount
        if(lngCount>127){
          bankName = bankNames[1];
          strLocation=strLocations[(lngCount-128)/16];
          strNumber = String.valueOf((lngCount-128) + 1);
        }else{
          bankName = bankNames[0];
          strLocation=strLocations[lngCount/16];
          strNumber = String.valueOf(lngCount + 1);
        }
        //add the rowset to the list
        rowSet.addRow(new Object[]{strLocation,strNumber,bankName,strVoiceCat,strVoiceName,strVoiceType,strLayerCount});
        lngCount++;
      }//for
      sf.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
   }

   void fileExit_ActionPerformed(ActionEvent e) {
     System.exit(0);
   }

   void fileLoad_ActionPerformed(ActionEvent e) {
    FileDialog fileDialog = new FileDialog(this,"Load file");
    fileDialog.show();
    jTextField1.setText(fileDialog.getDirectory() + fileDialog.getFile());
    if(jTextField1.getText()!=null && !jTextField1.getText().equals(""))
      initialize();
   }

  void jButton1_actionPerformed(ActionEvent e) {
    FileDialog fileDialog = new FileDialog(this,"Load file");
    fileDialog.show();
    jTextField1.setText(fileDialog.getDirectory() + fileDialog.getFile());
    if(jTextField1.getText()!=null && !jTextField1.getText().equals(""))
      initialize();
  }

}  // class RomasTester

